#!/bin/bash
#
# Matteo Cappadonna (matteo.cappadonna@me.com) - 2011/09/19
#
# This script receives input from sec.pl concerning translated snmptraps
#
# Ex: ./snmptraphandling.sh $1 $2 "$3" $4

usage () {
	echo "usage: $0 <HOST> <SEVERITY> \"<DATA>\" [UP|DOWN] [ALARMED HOST]"
}

# Inizia qui, comincio ad acquisire gli argomenti passati
[ ${#1} -eq 0 ] && usage && exit 1
HOST=$1

[ ${#2} -eq 0 ] && usage && exit 1
SEVERITY=$2

[ ${#3} -eq 0 ] && usage && exit 1
MONDATA_RES="$3"

HOST_STATUS=""
[ ${#4} -ne 0 ] && HOST_STATUS=$4

NAGIOS_HOST=`grep -2 $HOST /etc/nagios3/conf.d/*hosts* | grep host_name | head -1 | awk '{print $3}'`

ALARMED_HOST="$NAGIOS_HOST"
[ ${#5} -ne 0 ] && ALARMED_HOST=$5

# Nel caso in cui non ho indicazioni sullo stato dell'host/servizio, controllo il severity passato
RETURN_CODE=0
SERVICE_SUFFIX="unknown"

[ "$SEVERITY" = "INFORMATIONAL" ] && RETURN_CODE=0 && SERVICE_SUFFIX="$ALARMED_HOST-ok"
[ "$SEVERITY" = "Normal" ] && RETURN_CODE=0 && SERVICE_SUFFIX="$ALARMED_HOST-ok"
[ "$SEVERITY" = "SEVERE" ] && RETURN_CODE=2 && SERVICE_SUFFIX="$ALARMED_HOST-critical"
[ "$SEVERITY" = "MAJOR" ] && RETURN_CODE=2 && SERVICE_SUFFIX="$ALARMED_HOST-critical"
[ "$SEVERITY" = "CRITICAL" ] && RETURN_CODE=2 && SERVICE_SUFFIX="$ALARMED_HOST-critical"
[ "$SEVERITY" = "WARNING" ] && RETURN_CODE=1 && SERVICE_SUFFIX="$ALARMED_HOST-warning"
[ "$SEVERITY" = "MINOR" ] && RETURN_CODE=1 && SERVICE_SUFFIX="$ALARMED_HOST-warning"

# Altrimenti, definisco return code e service suffix, prendendo gli ultimi parametri
[ "$HOST_STATUS" = "DOWN" ] && RETURN_CODE=2 && SERVICE_SUFFIX="$ALARMED_HOST" && CHECK_SEVERITY=0
[ "$HOST_STATUS" = "UP" ] && RETURN_CODE=0 && SERVICE_SUFFIX="$ALARMED_HOST" && CHECK_SEVERITY=0

# Alcune variabili comode (Nagios vuole l'ora in Epoch intero)
TIME=`date +%s`
MONDATA="$2"
OUTPUT="/var/lib/nagios3/rw/nagios.cmd"

# Compongo il messaggio per Nagios
RESULTS="[$TIME] PROCESS_SERVICE_CHECK_RESULT;$NAGIOS_HOST;snmp_trap_handling_$SERVICE_SUFFIX;$RETURN_CODE;$MONDATA\n"

# Lo sparo nel nagios.cmd
echo -e $RESULTS >> $OUTPUT

